package handler

import (
	"context"
	"net/http"

	httpsrv "go.unistack.org/micro-server-http/v3"
	"go.unistack.org/pkgdash/internal/models"
	pb "go.unistack.org/pkgdash/proto"
)

func (h *Handler) PackageModules(ctx context.Context, req *pb.PackageModulesReq, rsp *pb.PackageModulesRsp) error {
	h.logger.Debug(ctx, "PackageModules handler start")

	modules, err := h.store.PackageModules(ctx, req)
	if err != nil {
		h.logger.Error(ctx, "error db response: %v", err)
		httpsrv.SetRspCode(ctx, http.StatusInternalServerError)
		return httpsrv.SetError(NewInternalError(err))
	}

	for _, mod := range modules {
		rsp.Modules = append(rsp.Modules, models.NewModule(mod))
	}
	h.logger.Debug(ctx, "PackagesModules handler stop")
	return nil
}
